/* -*- mode: c++; c-basic-offset: 4; -*- */
#ifndef CHECKSUM_CRC32_HH
#define CHECKSUM_CRC32_HH
#include <string>
#include <stdint.h>

class checksum_crc32 {
public:
    checksum_crc32(void);
    virtual ~checksum_crc32(void);
    void add(const unsigned char*, uint32_t length);
    void add(const std::string& str);
    void reset(void);
    uint32_t result(void) const;
private:
    uint32_t _value;
    uint32_t _length;
};

//======================================  Inline methods.
inline void
checksum_crc32::add(const std::string& str) {
    add(reinterpret_cast<const unsigned char*>(str.c_str()), str.size());
}

#endif // !defined(CHECKSUM_CRC32_HH)
